zoukankan      html  css  js  c++  java
  • 576. Out of Boundary Paths

    There is an m by n grid with a ball. Given the start coordinate (i,j) of the ball, you can move the ball to adjacent cell or cross the grid boundary in four directions (up, down, left, right). However, you can at most move N times. Find out the number of paths to move the ball out of grid boundary. The answer may be very large, return it after mod 109 + 7.

    Example 1:

    Input: m = 2, n = 2, N = 2, i = 0, j = 0
    Output: 6
    Explanation:
    

    Example 2:

    Input: m = 1, n = 3, N = 3, i = 0, j = 1
    Output: 12
    Explanation:
    

    Note:

    1. Once you move the ball out of boundary, you cannot move it back.
    2. The length and height of the grid is in range [1,50].
    3. N is in range [0,50].
     

    Approach #1: DP. [C++]

    class Solution {
    public:
        int findPaths(int m, int n, int N, int i, int j) {
            const int mod = 1000000007;
            vector<vector<vector<int>>> dp(N+1, vector<vector<int>>(m, vector<int>(n, 0)));
            vector<int> dirs = {1, 0, -1, 0, 1};
            for (int s = 1; s <= N; ++s) {
                for (int x = 0; x < m; ++x) {
                    for (int y = 0; y < n; ++y) {
                        for (int k = 0; k < 4; ++k) {
                            int dx = x + dirs[k];
                            int dy = y + dirs[k+1];
                            if (dx < 0 || dy < 0 || dx >= m || dy >= n) 
                                dp[s][x][y] += 1;
                            else 
                                dp[s][x][y] = (dp[s][x][y] + dp[s-1][dx][dy]) % mod;
                        }
                    }
                }
            }
            return dp[N][i][j];
        }
    };
    

      

    Analysis:

    Observation:

    Number of paths start from (i, j) to out of boundary <=> Number of paths start from out of boundary to (i, j).

    dp[N][i][j] : Number of paths start from out of boundary to (i, j) by moving N steps.

    dp[*][y][x] = 1, if (x, y) are out of boundary

    dp[s][i][j] = dp[s-1][i+1][j] + dp[s-1][i-1][j] + dp[s-1][i][j+1] + dp[s-1][i][j-1]

    Ans: dp[N][i][j]

    Time complexity: O(N*m*n)

    Space complexity: O(N*m*n) -> O(m*n)

    Reference:

    http://zxi.mytechroad.com/blog/dynamic-programming/leetcode-576-out-of-boundary-paths/

    永远渴望,大智若愚(stay hungry, stay foolish)
  • 相关阅读:
    28、列举常见的内置函数(各个函数的示例,一大半没写全,慢慢更新,会全的)
    Django之前端插件定制之表头
    26、Python的可变类型和不可变类型?
    25、Python垃圾回收机制?
    24、简述Python的深浅拷贝以及应用场景
    基础题(五)
    使用OpenCV和Python进行人脸识别
    Codeforces Round #253 (Div. 2)B(暴力枚举)
    uva11609(组合数学,快速幂)
    uva10892(暴力枚举)
  • 原文地址:https://www.cnblogs.com/h-hkai/p/10498491.html
Copyright © 2011-2022 走看看